"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _utils = require("react-jsonschema-form/lib/utils");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils2 = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CollapseMenuAction = function (_Component) {
  _inherits(CollapseMenuAction, _Component);

  function CollapseMenuAction() {
    _classCallCheck(this, CollapseMenuAction);

    return _possibleConstructorReturn(this, (CollapseMenuAction.__proto__ || Object.getPrototypeOf(CollapseMenuAction)).apply(this, arguments));
  }

  _createClass(CollapseMenuAction, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          action = _props.action,
          _props$allActions = _props.allActions,
          allActions = _props$allActions === undefined ? {} : _props$allActions;

      if (!action) {
        return null;
      }
      if (typeof action === "string") {
        return _react2.default.createElement(
          "div",
          null,
          action
        );
      } else if ((typeof action === "undefined" ? "undefined" : _typeof(action)) === "object") {
        var _Component2 = allActions[action.component];
        if (!_Component2) {
          console.error("Can't find " + action.component + " in formContext.allActions");
          return _react2.default.createElement(
            "h2",
            { className: "warning bg-error", style: { color: "red" } },
            "Can't find ",
            _react2.default.createElement(
              "b",
              null,
              action.component
            ),
            " in ",
            _react2.default.createElement(
              "b",
              null,
              "formContext"
            ),
            ".",
            _react2.default.createElement(
              "b",
              null,
              "allActions"
            )
          );
        }
        return _react2.default.createElement(_Component2, action.props);
      }
    }
  }]);

  return CollapseMenuAction;
}(_react.Component);

function CollapseMenu(props) {
  var headerElementsSchemas = props.headerElementsSchemas,
      uiSchema = props.uiSchema,
      _props$formContext = props.formContext,
      formContext = _props$formContext === undefined ? {} : _props$formContext,
      _props$formData = props.formData,
      formData = _props$formData === undefined ? {} : _props$formData,
      onChange = props.onChange,
      onAdd = props.onAdd,
      title = props.title,
      name = props.name,
      collapsed = props.collapsed,
      fields = props.fields,
      propsOnChange = props.propsOnChange;
  var _uiSchema$collapse = uiSchema.collapse,
      _uiSchema$collapse$co = _uiSchema$collapse.collapsibleHeaderElements,
      collapsibleHeaderElements = _uiSchema$collapse$co === undefined ? {} : _uiSchema$collapse$co,
      _uiSchema$collapse$ic = _uiSchema$collapse.icon;
  _uiSchema$collapse$ic = _uiSchema$collapse$ic === undefined ? {} : _uiSchema$collapse$ic;
  var _uiSchema$collapse$ic2 = _uiSchema$collapse$ic.enabled,
      enabled = _uiSchema$collapse$ic2 === undefined ? "glyphicon glyphicon-chevron-down" : _uiSchema$collapse$ic2,
      _uiSchema$collapse$ic3 = _uiSchema$collapse$ic.disabled,
      disabled = _uiSchema$collapse$ic3 === undefined ? "glyphicon glyphicon-chevron-right" : _uiSchema$collapse$ic3,
      _uiSchema$collapse$ic4 = _uiSchema$collapse$ic.add,
      add = _uiSchema$collapse$ic4 === undefined ? "glyphicon glyphicon-plus-sign" : _uiSchema$collapse$ic4,
      _uiSchema$collapse$se = _uiSchema$collapse.separate,
      separate = _uiSchema$collapse$se === undefined ? true : _uiSchema$collapse$se,
      addTo = _uiSchema$collapse.addTo,
      _uiSchema$collapse$wr = _uiSchema$collapse.wrapClassName,
      wrapClassName = _uiSchema$collapse$wr === undefined ? "lead" : _uiSchema$collapse$wr,
      _uiSchema$collapse$ac = _uiSchema$collapse.actions,
      actions = _uiSchema$collapse$ac === undefined ? [] : _uiSchema$collapse$ac,
      _uiSchema$collapse$cl = _uiSchema$collapse.classNames,
      classNames = _uiSchema$collapse$cl === undefined ? "collapsibleHeading" : _uiSchema$collapse$cl,
      _uiSchema$collapse$co2 = _uiSchema$collapse.collapseDivStyles;
  _uiSchema$collapse$co2 = _uiSchema$collapse$co2 === undefined ? {} : _uiSchema$collapse$co2;
  var _uiSchema$collapse$co3 = _uiSchema$collapse$co2.textColor,
      textColor = _uiSchema$collapse$co3 === undefined ? "white" : _uiSchema$collapse$co3,
      _uiSchema$collapse$co4 = _uiSchema$collapse$co2.background,
      background = _uiSchema$collapse$co4 === undefined ? "linear-gradient(to right, #0472B6, white)" : _uiSchema$collapse$co4,
      _uiSchema$collapse$co5 = _uiSchema$collapse$co2.collapseGlyphColor,
      collapseGlyphColor = _uiSchema$collapse$co5 === undefined ? "white" : _uiSchema$collapse$co5,
      _uiSchema$collapse$co6 = _uiSchema$collapse$co2.addGlyphColor,
      addGlyphColor = _uiSchema$collapse$co6 === undefined ? "white" : _uiSchema$collapse$co6,
      _uiSchema$collapse$co7 = _uiSchema$collapse$co2.padding,
      padding = _uiSchema$collapse$co7 === undefined ? "14px" : _uiSchema$collapse$co7,
      _uiSchema$collapse$co8 = _uiSchema$collapse$co2.margin,
      margin = _uiSchema$collapse$co8 === undefined ? "" : _uiSchema$collapse$co8,
      _uiSchema$collapse$co9 = _uiSchema$collapse$co2.marginLeft,
      marginLeft = _uiSchema$collapse$co9 === undefined ? "-5px" : _uiSchema$collapse$co9,
      _uiSchema$collapse$co10 = _uiSchema$collapse$co2.marginBottom,
      marginBottom = _uiSchema$collapse$co10 === undefined ? "5px" : _uiSchema$collapse$co10,
      _uiSchema$collapse$co11 = _uiSchema$collapse$co2.zIndex,
      zIndex = _uiSchema$collapse$co11 === undefined ? -1 : _uiSchema$collapse$co11,
      _uiSchema$collapse$co12 = _uiSchema$collapse$co2.divCursor,
      divCursor = _uiSchema$collapse$co12 === undefined ? "pointer" : _uiSchema$collapse$co12,
      _uiSchema$collapse$co13 = _uiSchema$collapse$co2.addCursor,
      addCursor = _uiSchema$collapse$co13 === undefined ? "copy" : _uiSchema$collapse$co13;


  var handleAdd = function handleAdd(event) {
    event.stopPropagation();
    onAdd(event);
  };

  var headerElements = [];
  var _collapsibleHeaderEle = collapsibleHeaderElements.className,
      headerElementsWrapperClass = _collapsibleHeaderEle === undefined ? "header-element-wrapper" : _collapsibleHeaderEle;


  Object.keys(headerElementsSchemas).map(function (key) {
    var fieldSchema = headerElementsSchemas[key];
    var fieldName = (0, _utils2.getFieldName)(fieldSchema.type);

    if (fieldName) {
      var FieldElement = fields[fieldName];
      var fieldId = "" + key;
      var fieldUiSchema = uiSchema[key];
      var fieldFormData = formData[key];

      var elementOnChange = function elementOnChange(value, options) {
        formData[key] = value;
        propsOnChange(formData, options);
      };

      headerElements.push(_react2.default.createElement(FieldElement, {
        formContext: formContext,
        formData: fieldFormData,
        idSchema: { $id: fieldId },
        key: key,
        onChange: elementOnChange,
        schema: fieldSchema,
        uiSchema: fieldUiSchema
      }));
    }
  });

  return _react2.default.createElement(
    "div",
    { className: "" + wrapClassName },
    _react2.default.createElement(
      "div",
      {
        className: classNames,
        onClick: onChange,
        style: {
          padding: padding,
          margin: margin,
          marginLeft: marginLeft,
          marginBottom: marginBottom,
          zIndex: zIndex,
          cursor: divCursor,
          background: background
        }
      },
      _react2.default.createElement(
        "span",
        { style: { color: textColor } },
        title || name
      ),
      "\xA0",
      addTo && _react2.default.createElement(
        "a",
        {
          onClick: handleAdd,
          style: { color: addGlyphColor, cursor: addCursor }
        },
        _react2.default.createElement("i", { style: { cursor: addCursor }, className: add })
      ),
      _react2.default.createElement(
        "a",
        null,
        _react2.default.createElement("i", {
          style: { color: collapseGlyphColor },
          className: collapsed ? disabled : enabled
        })
      ),
      !!headerElements.length && _react2.default.createElement(
        "div",
        {
          className: headerElementsWrapperClass,
          onClick: function onClick(event) {
            return event.stopPropagation();
          }
        },
        headerElements
      ),
      actions.map(function (action, i) {
        return _react2.default.createElement(CollapseMenuAction, {
          key: i,
          action: action,
          allActions: formContext.allActions
        });
      })
    ),
    separate && _react2.default.createElement("hr", null)
  );
}

var CollapseLegend = function (_Component3) {
  _inherits(CollapseLegend, _Component3);

  function CollapseLegend() {
    _classCallCheck(this, CollapseLegend);

    return _possibleConstructorReturn(this, (CollapseLegend.__proto__ || Object.getPrototypeOf(CollapseLegend)).apply(this, arguments));
  }

  _createClass(CollapseLegend, [{
    key: "render",
    value: function render() {
      var _props2 = this.props,
          legend = _props2.uiSchema.collapse.legend,
          _props2$formContext = _props2.formContext;
      _props2$formContext = _props2$formContext === undefined ? {} : _props2$formContext;
      var _props2$formContext$l = _props2$formContext.legends,
          legends = _props2$formContext$l === undefined ? {} : _props2$formContext$l;

      if (!legend) {
        return null;
      }
      if (typeof legend === "string") {
        return _react2.default.createElement(
          "div",
          null,
          legend
        );
      } else if ((typeof legend === "undefined" ? "undefined" : _typeof(legend)) === "object") {
        var _Component4 = legends[legend.component];
        if (!_Component4) {
          console.error("Can't find " + legend.components + " in formContext.legends");
          return _react2.default.createElement(
            "h2",
            { className: "warning bg-error", style: { color: "red" } },
            "Can't find ",
            _react2.default.createElement(
              "b",
              null,
              legend.component
            ),
            " in ",
            _react2.default.createElement(
              "b",
              null,
              "formContext"
            ),
            ".",
            _react2.default.createElement(
              "b",
              null,
              "legends"
            )
          );
        }
        return _react2.default.createElement(_Component4, legend.props);
      }
      return _react2.default.createElement(
        "div",
        null,
        "I'm a legend"
      );
    }
  }]);

  return CollapseLegend;
}(_react.Component);

var CollapsibleField = function (_Component5) {
  _inherits(CollapsibleField, _Component5);

  function CollapsibleField(props) {
    _classCallCheck(this, CollapsibleField);

    var _this3 = _possibleConstructorReturn(this, (CollapsibleField.__proto__ || Object.getPrototypeOf(CollapsibleField)).call(this, props));

    _this3.appendToArray = function () {
      var formData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var newVal = arguments[1];
      var _this3$props$uiSchema = _this3.props.uiSchema.collapse;
      _this3$props$uiSchema = _this3$props$uiSchema === undefined ? {} : _this3$props$uiSchema;
      var _this3$props$uiSchema2 = _this3$props$uiSchema.addToBottom,
          addToBottom = _this3$props$uiSchema2 === undefined ? true : _this3$props$uiSchema2;

      if (formData.some(function (v) {
        return (0, _utils.deepEquals)(v, newVal);
      })) {
        return formData;
      } else {
        // newVal can be either array or a single element, concat flattens value
        if (addToBottom) {
          return formData.concat(newVal);
        } else {
          return [newVal].concat(formData);
        }
      }
    };

    _this3.doAdd = function (field, formData, newVal) {
      if (field === "self") {
        _this3.props.onChange(_this3.appendToArray(formData, newVal));
      } else {
        var fieldVal = _this3.appendToArray(formData[field], newVal);
        var change = Object.assign({}, formData, _defineProperty({}, field, fieldVal));
        _this3.props.onChange(change);
      }
    };

    _this3.handleAdd = function () {
      _this3.setState({ collapsed: false });
      _this3.forceUpdate(function () {
        var _this3$props = _this3.props,
            schema = _this3$props.schema,
            uiSchema = _this3$props.uiSchema,
            formData = _this3$props.formData,
            fields = _this3$props.registry.fields,
            formContext = _this3$props.formContext;
        var _uiSchema$collapse2 = uiSchema.collapse,
            addTo = _uiSchema$collapse2.addTo,
            addElement = _uiSchema$collapse2.addElement;


        var fieldSchema = addTo === "self" ? schema.items : schema.properties ? schema.properties[addTo] ? schema.properties[addTo].items : null : null;
        if (!fieldSchema) {
          return false;
        }
        var fieldUiSchema = addTo === "self" ? uiSchema : uiSchema[addTo];
        var fieldFormData = addTo === "self" ? formData : formData[addTo];

        if (addElement) {
          if (typeof addElement === "function") {
            var onSubmit = function onSubmit(newVal) {
              _this3.setState({ AddElement: undefined });
              _this3.doAdd(addTo, formData, newVal);
            };
            var AddElement = addElement(fieldSchema, fieldUiSchema, onSubmit);
            _this3.setState({ AddElement: AddElement });
          } else {
            var FieldElement = fields[addElement];
            var onBlur = function onBlur(newVal) {
              _this3.setState({ AddElement: undefined });
              _this3.doAdd(addTo, formData, newVal);
            };
            var _AddElement = function _AddElement() {
              return _react2.default.createElement(FieldElement, {
                schema: fieldSchema,
                uiSchema: fieldUiSchema,
                onChange: function onChange(formData) {
                  onBlur(formData);
                },
                formContext: formContext,
                formData: fieldFormData
              });
            };
            _this3.setState({ AddElement: _AddElement });
          }
        } else {
          var newVal = (0, _utils.getDefaultFormState)(fieldSchema, {});
          _this3.doAdd(addTo, formData, newVal);
        }
      });
    };

    _this3.handleCollapsed = function () {
      _this3.setState(function (state) {
        return { collapsed: !state.collapsed };
      });
    };

    var _props$uiSchema$colla = props.uiSchema.collapse;
    _props$uiSchema$colla = _props$uiSchema$colla === undefined ? {} : _props$uiSchema$colla;
    var _props$uiSchema$colla2 = _props$uiSchema$colla.collapsed,
        collapsed = _props$uiSchema$colla2 === undefined ? true : _props$uiSchema$colla2;


    _this3.state = { collapsed: collapsed };
    return _this3;
  }

  _createClass(CollapsibleField, [{
    key: "componentDidCatch",
    value: function componentDidCatch(error, errorInfo) {
      // You can also log the error to an error reporting service
      console.log({ error: error, errorInfo: errorInfo });
    }
  }, {
    key: "render",
    value: function render() {
      var _props3 = this.props,
          _props3$schema = _props3.schema,
          title = _props3$schema.title,
          _props3$schema$proper = _props3$schema.properties,
          properties = _props3$schema$proper === undefined ? {} : _props3$schema$proper,
          uiSchema = _props3.uiSchema,
          fields = _props3.registry.fields,
          _props3$idSchema = _props3.idSchema;
      _props3$idSchema = _props3$idSchema === undefined ? {} : _props3$idSchema;
      var $id = _props3$idSchema.$id,
          name = _props3.name,
          formContext = _props3.formContext,
          formData = _props3.formData,
          propsOnChange = _props3.onChange;
      var _state = this.state,
          collapsed = _state.collapsed,
          AddElement = _state.AddElement;
      var _uiSchema$collapse3 = uiSchema.collapse,
          _uiSchema$collapse3$c = _uiSchema$collapse3.collapsibleHeaderElements,
          collapsibleHeaderElements = _uiSchema$collapse3$c === undefined ? {} : _uiSchema$collapse3$c,
          field = _uiSchema$collapse3.field;

      var CollapseElement = fields[field];
      var _collapsibleHeaderEle2 = collapsibleHeaderElements.elements,
          elements = _collapsibleHeaderEle2 === undefined ? [] : _collapsibleHeaderEle2;
      // uischema retains the value for the state

      uiSchema.collapse.collapsed = this.state.collapsed;

      title = uiSchema["ui:title"] ? uiSchema["ui:title"] : title ? title : name;
      var customizedId = collapsed ? $id : undefined;

      //remove header elements from the schema
      var headerElementsSchemas = {};
      var propertiesNoHeader = _extends({}, properties);
      var orderNoHeader = uiSchema["ui:order"] ? uiSchema["ui:order"].filter(function (x) {
        return elements.indexOf(x) < 0;
      }) : uiSchema["ui:order"];

      elements.forEach(function (key) {
        if (propertiesNoHeader[key]) {
          headerElementsSchemas[key] = propertiesNoHeader[key];
          delete propertiesNoHeader[key];
        }
      });

      var collapseElementProps = _extends({}, this.props, {
        schema: _extends({}, this.props.schema, { properties: propertiesNoHeader }),
        uiSchema: _extends({}, this.props.uiSchema, { "ui:order": orderNoHeader })
      });

      return _react2.default.createElement(
        "div",
        { id: customizedId },
        _react2.default.createElement(CollapseMenu, {
          headerElementsSchemas: headerElementsSchemas,
          collapsibleFieldId: $id,
          title: title,
          uiSchema: uiSchema,
          collapsed: collapsed,
          formContext: formContext,
          formData: formData,
          fields: fields,
          onAdd: this.handleAdd,
          onChange: this.handleCollapsed,
          propsOnChange: propsOnChange
        }),
        _react2.default.createElement(
          "div",
          { className: "form-group" },
          AddElement && _react2.default.createElement(AddElement, null),
          !collapsed && _react2.default.createElement(CollapseLegend, this.props),
          !collapsed && _react2.default.createElement(CollapseElement, collapseElementProps)
        )
      );
    }
  }]);

  return CollapsibleField;
}(_react.Component);

CollapsibleField.propTypes = {
  uiSchema: _propTypes2.default.shape({
    collapse: _propTypes2.default.shape({
      field: _propTypes2.default.string.isRequired,
      icon: _propTypes2.default.shape({
        enabled: _propTypes2.default.string,
        disabled: _propTypes2.default.string,
        add: _propTypes2.default.string
      }),
      separate: _propTypes2.default.boolean,
      addTo: _propTypes2.default.string,
      addElement: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.string]),
      legend: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.shape({
        component: _propTypes2.default.string.isRequired,
        props: _propTypes2.default.object
      })]),
      actions: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        component: _propTypes2.default.string.isRequired,
        props: _propTypes2.default.object
      })),
      wrapClassName: _propTypes2.default.string
    }).isRequired
  }).isRequired,
  registry: _propTypes2.default.shape({
    fields: _propTypes2.default.object.isRequired
  }).isRequired
};

exports.default = CollapsibleField;